/************************************************************************************
The code is designed and produced by MDY Science and Education Co., Ltd, which has the entire ownership. It is only for personal learning, which cannot be used for commercial or profit-making purposes without permission.

    MDY's Mission: Develop Chip Talents and Realize National Chip Dream.

    We sincerely hope that our students can learn the real IC / FPGA code through our standard and rigorous code.

    For more FPGA learning materials, please visit the Forum: http://fpgabbs.com/ and official website: http://www.mdy-edu.com/index.html 

    *************************************************************************************/

module top_mdyPwdlock_keyscan(
    clk             ,   
    rst_n           ,   

    key_col         ,
    key_row         ,

    seg_sel         ,  
    segment            
    
    );

    input               clk                 ;
    input               rst_n               ;
    input [3:0]         key_col             ;

    output[5:0]         seg_sel             ;
    output[7:0]         segment             ;
    output[3:0]         key_row             ;

    wire  [5:0]         seg_sel             ;
    wire  [7:0]         segment             ;
    wire  [3:0]         key_row             ;

    wire  [3:0]         key_out             ;
    wire                key_vld             ;
    wire  [6*5-1:0]     seg_dout            ;
    wire  [5:0]         seg_dout_vld        ;

    
   
    key_scan u_key_scan(
        .clk                (clk           ),        
        .rst_n              (rst_n         ),     
        .key_col            (key_col       ),
        .key_row            (key_row       ),
        .key_out            (key_out       ),
        .key_vld            (key_vld       )
    );



    /****************************STATEMENT_BEGIN**************************
    CTRL
    ******************************STATEMENT_END***************************/
    control u_ctrl(
        .clk                (clk            ),       
        .rst_n              (rst_n          ),       
                                      
        .key_num            (key_out        ),       
        .key_vld            (key_vld        ),       
                                      
        .seg_dout           (seg_dout       ),       
        .seg_dout_vld       (seg_dout_vld   )        
    );



    /****************************STATEMENT_BEGIN**************************
    SEGMENT
    ******************************STATEMENT_END***************************/
    seg_display u_segment(
        .clk                (clk            ),       
        .rst_n              (rst_n          ),       

        .din                (seg_dout       ),       
        .din_vld            (seg_dout_vld   ),      

        .segment            (segment        ),       
        .seg_sel            (seg_sel        )        
    );



    endmodule

